/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// Dialog360Tier the model 'Dialog360Tier'
type Dialog360Tier string

// List of Dialog360Tier
const (
	TierDefault Dialog360Tier = "default"
	TierBasic Dialog360Tier = "basic"
	TierRegular Dialog360Tier = "regular"
	TierPremium Dialog360Tier = "premium"
)

// All allowed values of Dialog360Tier enum
var AllowedDialog360TierEnumValues = []Dialog360Tier{
	"default",
	"basic",
	"regular",
	"premium",
}

func (v *Dialog360Tier) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := Dialog360Tier(value)
	for _, existing := range AllowedDialog360TierEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid Dialog360Tier", value)
}

// NewDialog360TierFromValue returns a pointer to a valid Dialog360Tier
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewDialog360TierFromValue(v string) (*Dialog360Tier, error) {
	ev := Dialog360Tier(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for Dialog360Tier: valid values are %v", v, AllowedDialog360TierEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v Dialog360Tier) IsValid() bool {
	for _, existing := range AllowedDialog360TierEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to Dialog360Tier value
func (v Dialog360Tier) Ptr() *Dialog360Tier {
	return &v
}

type NullableDialog360Tier struct {
	value *Dialog360Tier
	isSet bool
}

func (v NullableDialog360Tier) Get() *Dialog360Tier {
	return v.value
}

func (v *NullableDialog360Tier) Set(val *Dialog360Tier) {
	v.value = val
	v.isSet = true
}

func (v NullableDialog360Tier) IsSet() bool {
	return v.isSet
}

func (v *NullableDialog360Tier) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDialog360Tier(val *Dialog360Tier) *NullableDialog360Tier {
	return &NullableDialog360Tier{value: val, isSet: true}
}

func (v NullableDialog360Tier) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDialog360Tier) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

